<template>
  <div>
    <div class="label">Overview</div>

    <div class="grid-cards">
      <div id="card-earn" class="card shadow h-100">
        <div class="card-img h-100 pt-4">
          <ChartArea
            height="100%"
            width="100%"
            color="#FFCC00"
            opacity="0.65"
            :chartData="stats.dayTips"
            :animationDuration="animDuration"
          />
        </div>
        <div class="card-img-overlay">
          <h5 class="card-title">EARN</h5>
          <p class="ms-2">
            <NumberCountUp
              class="card-number text-nowrap"
              :number="(wallet?.amount || 0) / 1000"
              :duration="animDuration"
            />
            <span class="text-muted ms-1 text-nowrap">sats</span>
          </p>
        </div>
      </div>

      <div id="card-tips" class="card shadow">
        <div class="card-img pt-4">
          <ChartArea
            height="120px"
            width="100%"
            color="#00ff00"
            :chartData="stats.numTips"
            :animationDuration="animDuration"
          />
        </div>
        <div class="card-img-overlay">
          <h5 class="card-title">NUMBER OF TIPS</h5>
          <p class="ms-2">
            <NumberCountUp
              class="card-number text-nowrap"
              :number="wallet?.tipsCount"
              :duration="animDuration"
            />
            <span class="text-muted ms-1 text-nowrap">tips</span>
          </p>
        </div>
      </div>

      <div id="card-average" class="card shadow">
        <div class="card-img pt-4">
          <ChartArea
            height="120px"
            width="100%"
            color="#0000ff"
            :chartData="stats.avgTips"
            :animationDuration="animDuration"
          />
        </div>
        <div class="card-img-overlay">
          <h5 class="card-title">AVERAGE TIP</h5>
          <p class="ms-2">
            <NumberCountUp
              class="card-number text-nowrap"
              :number="(averageTip || 0) / 1000"
              :duration="animDuration"
            />
            <span class="text-muted ms-1 text-nowrap">sats</span>
          </p>
        </div>
      </div>
    </div>

    <div class="label mt-5">Recent Tips:</div>
    <TipsList :count="6" />
  </div>
</template>

<script>
import ChartArea from "../components/ChartProfile.vue";
import NumberCountUp from "../components/NumberCountUp.vue";
import TipsList from "../components/TipsList.vue";
export default {
  components: { ChartArea, NumberCountUp, TipsList },
  name: "ProfileOverview",
  data() {
    return {
      animDuration: 1000,
    };
  },
  computed: {
    wallet() {
      return this.$store.state.wallets.wallet;
    },
    stats() {
      if (!this.wallet?.stats) {
        return {
          dayTips: undefined,
          numTips: undefined,
          avgTips: undefined,
        };
      } else if (this.wallet?.stats?.dayTips <= 1) {
        return {
          dayTips: [1, 1],
          numTips: [1, 1],
          avgTips: [1, 1],
        };
      } else return this.wallet.stats;
    },
    averageTip() {
      var avrgTip = 0.0;
      if (this.wallet?.tipsCount)
        avrgTip = parseFloat(
          this.wallet?.amount / this.wallet?.tipsCount
        ).toFixed(1);
      return avrgTip;
    },
  },
  async beforeCreate() {
    this.$store.dispatch("loadWallet", true);
  },
};
</script>

<style lang="scss" scoped>
.grid-cards {
  display: grid;
  grid-template-columns: 1.5fr 1fr 1fr;
  grid-auto-rows: minmax(180px, auto);
  grid-gap: 1.5em;
  align-items: end;
}

.card {
  .card-title {
    color: $gray-600;
    font-size: 0.9em;
    font-weight: 600;
  }

  .card-number {
    color: $black;
    font-weight: 600;
  }
}

#card-earn {
  .card-number {
    font-size: 2.2em;
  }
}

#card-tips,
#card-average {
  .card-number {
    font-size: 1.7em;
  }
}
</style>

<style lang="scss">
.vue-apexcharts svg {
  border-radius: $card-border-radius;
}
</style>